#!/usr/bin/perl -w

use lib '/usr/sausalito/perl';
use CCE;
use Sauce::Util;

my $cce = new CCE;
$cce->connectfd();

my $DEBUG=0;

if($DEBUG){
	open D,"+>/tmp/deleteTunnel.pl.$$";
	print D scalar localtime;
}

my $old = $cce->event_old();

my $startString = "# BEGIN auto-generated tunnel $old->{name}.  DO NOT EDIT";
my $endString = "# END auto-generated tunnel $old->{name}.  DO NOT EDIT";

print D "$startString\n$endString\n" if $DEBUG;

my $tname = $old->{name};
$tname =~ s/\s/_/g;

print D $tname if $DEBUG;

if($old->{keying} eq "maunal"){
	print D "keying = manual\n" if $DEBUG;
	my $t;
	$t=`ipsec manual --down $tname-$_` foreach(qw/nn hh hn nh/);
	$t.=`ipsec manual --unroute $tname-$_` foreach(qw/nn hh hn nh/);
	print D $t if $DEBUG;
}else{
	print D "keying != manual\n" if $DEBUG;
	my $t=`ipsec auto --delete $tname-$_` foreach(qw/nn hh hn nh/);
	print D $t if $DEBUG;
}

$ret=Sauce::Util::replaceblock(
        "/etc/freeswan/ipsec.conf.tunnels",
        $startString,
        undef,
        $endString,
        0600  
);

if($DEBUG){
	print D "\n$ret\n";
	close D;
}

$cce->bye("SUCCESS");
exit(0);
