#!/usr/bin/perl -w

use lib '/usr/sausalito/perl';
use CCE;
use Sauce::Util;

my $cce = new CCE;
$cce->connectfd();

my $DEBUG=0;

if($DEBUG){
	open D, "+>/tmp/editProfile.pl.$$";
	print D scalar localtime;
}

my $obj = $cce->event_object();

my $connName = $obj->{name};
$connName =~ s/\s/_/g;

my $pfs = $obj->{pfs}?"yes":"no";


if($obj->{enableAutoRsa} || $obj->{enableAutoSecret}){
$autoConn = << "EOF";
conn $connName-auto
        auth=$obj->{auth}
        pfs=$pfs
        keylife=$obj->{keylife}m
        rekeymargin=$obj->{rekeymargin}m
        rekeyfuzz=$obj->{rekeyfuzz}%
        keyingtries=$obj->{keyingtries}
        ikelifetime=$obj->{ikelifetime}m

EOF
}else{
	$autoConn="";
}

print D "autoConn:\n" if $DEBUG;
print D $autoConn if $DEBUG;

if($obj->{enableManual}){
$manualConn = << "EOF";
conn $connName-manual
        $obj->{manualAuth}=$obj->{authValue}
        $obj->{manualAuth}replay_window=$obj->{replayWindow}

EOF
}else{
	$manualConn="";
}

print D "manualConn:\n" if $DEBUG;
print D $manualConn if $DEBUG;

my $startString = "# BEGIN auto-generated profile $obj->{name}, DO NOT EDIT\n";
my $profileString = << "EOF";
$autoConn

$manualConn

EOF

print D "profileString:\n" if $DEBUG;
print D $profileString if $DEBUG;

my $endString = "# END auto-generated profile $obj->{name}, DO NOT EDIT\n";

$ret=Sauce::Util::replaceblock(
	"/etc/freeswan/ipsec.conf.profiles",
	$startString,
	$profileString,
	$endString,
	0600
);

print D "ret=$ret\n" if $DEBUG;

$cce->bye("SUCCESS");
exit(0);
