#!/usr/bin/perl -w

use lib '/usr/sausalito/perl';
use CCE;
use Sauce::Util;

my $cce = new CCE;
$cce->connectfd();

my $obj = $cce->event_object();

#get eth0
@oids=$cce->find("Network", {device=>"eth0"});
(undef, $eth0)=$cce->get($oids[0]);
$localIps=$eth0->{ipaddr};

undef @oids;
#get eth1
@oids=$cce->find("Network", {device=>"eth1", enabled=>1});
if(scalar @oids){
	(undef, $eth1)=$cce->get($oids[0]);
	$localIps .= " $eth1->{ipaddr}";
}

if($obj->{CLASS} eq "Network"){
	#replace PSK ips
	@tunnels=$cce->find("IpsecTunnel", {keying=>"autoSecret"});
	foreach $oid (@tunnels){
		my $tunnel=$cce->get($oid);
		my $startString="#start pre-shared key for '$tunnel->{name}'.  DO NOT EDIT";
		my $secret="$localIps $tunnel->{remoteIp}: PSK \"$tunnel->{authKey}\"\n";
		my $endString="#end pre-shared key for '$tunnel->{name}'.  DO NOT EDIT";
 
                Sauce::Util::replaceblock(
                        "/etc/freeswan/ipsec.secrets",
                        $startString,
                        $secret,
                        $endString,
                        0600
                );
	}

	#replace rsa ip
	open IN, "/etc/freeswan/ipsec.secrets";
	open OUT, "+>/etc/freeswan/ipsec.secrets~";
	while(<IN>){
		s/[0-9\.\s]+: rsa/$localIps: rsa/;
		print OUT;
	}
	close OUT;
	close IN;
	system("cp /etc/freeswan/ipsec.secrets~ /etc/freeswan/ipsec.secrets");


}else{	#CLASS=IpsecTunnel

	if($obj->{keying} eq "autoSecret"){
	
		$startString="#start pre-shared key for '$obj->{name}'.  DO NOT EDIT";
		$secret="$localIps $obj->{remoteIp}: PSK \"$obj->{authKey}\"\n";
		$endString="#end pre-shared key for '$obj->{name}'.  DO NOT EDIT";

		Sauce::Util::replaceblock(
			"/etc/freeswan/ipsec.secrets",
			$startString,
			$secret,
			$endString,
			0600
		);

	}
}

`ipsec auto --rereadsecrets`;

$cce->bye("SUCCESS");
exit(0);

