#!/usr/bin/perl -w

use lib '/usr/sausalito/perl';
use CCE;

my $cce = new CCE;
$cce->connectfd();

my $DEBUG=0;

if($DEBUG){
	open D, "/tmp/restart.pl.$$";
	print D scalar localtime;
}


my $profile = $cce->event_object();
my $error  = 0;

my @oids = $cce->find("IpsecTunnel", {profile=>$profile->{name}});

print D "oids:  " if $DEBUG;
print D join ",", @oids if $DEBUG;

foreach(@oids){
	my $tunnel;
	(undef,$tunnel) = $cce->get($_);
	$keying = $tunnel->{keying} eq "manual"?"manual":"auto";
	$tname = $tunnel->{name};
	$tname =~ s/\s/_/g;

	if($DEBUG){
		print D "$_:\n";
		print D "name: $tunnel->{name}\n";
		print D "keying: $keying\n";
	}

	if($keying eq "auto"){
		print D "restarting, auto\n" if $DEBUG;
		if($obj->{enabled} ne "ignored"){
			print D "not ignored\n" if $DEBUG;
			my $t=`ipsec auto --reload $tname-$_` foreach(qw/nn hh hn nh/);
			print D $t if $DEBUG;
			if($obj->{enabled} eq "start"){
				print D "bringing it up...\n" if $DEBUG;
				my $t=`ipsec auto --up $tname-$_` foreach(qw/nn hh hn nh/);
				print D $t if $DEBUG;
			}
		}
	}else{
		print D "restarting, manual" if $DEBUG;
		if($obj->{enabled} ne "ignore"){
			print D "not ignored\n" if $DEBUG;
			my $t;
			$t=`ipsec manual --down $tname-$_` foreach(qw/nn hh hn nh/);
			$t.=`ipsec manual --unroute $tname-$_` foreach(qw/nn hh hn nh/);
			$t.=`ipsec manual --up $tname-$_` foreach(qw/nn hh hn nh/);
			print D $t if $DEBUG;
		}
	}
	print D "\n" if $DEBUG;
}

close D if $DEBUG;

$cce->bye("SUCCESS");
exit(0);
