#!/usr/bin/perl -w

my $tunnel = $ARGV[0];
my $start = $ARGV[1];
my $keying = $ARGV[2];
my @info = grep {/$tunnel-(?:nn|hh|hn|nh)/} (`/usr/sbin/ipsec whack --status`);
my %tunnels;
my $upcnt=0;

if($keying eq "manual"){
	#yeah, bad, I know, but pluto doesn't tell us crap 
	#about status for manual tunnels.
	@conns=`grep '$tunnel-' /etc/freeswan/ipsec.conf.tunnels`;
	%tunnels=map {(split/\s/,$_)[-1]=>1} @conns;
	$upcnt=scalar @conns;
	$start="start";
}else{
	foreach(@info){
		/"($tunnel-(?:nn|nh|hn|hh))"/;
		my $t=$1;
		#get up/down info
		#1=up, 0=down
		my $updown=0;
		if(/IPsec SA Established/i){
			$updown=1;
		}
	
		if($updown){
			$upcnt++;
		}
		$tunnels{$t}+=$updown;
	}
}


if($start eq "start"){
	#we are supposed to start the connection.
	#therefore if the tunnel is not up we have
	#a problem.

	if($upcnt==0){
		print "severeProblem\n";
	}else{
		#try a ping here?
		print "normal\n";
		print join " ", (map {(split/-/)[-1]} (grep {$tunnels{$_}==1} keys %tunnels));
		#-1 == last element
		print "\n";
	}
}else{
	#the other end is supposed to start the connection.
	#therefore we only have a problem if the connection
	#profile(s) are not in ipsec's memory.

	if(scalar keys %tunnels >= 1){
		print "normal\n";
		print join " ", (map {(split/-/)[-1]} (grep {$tunnels{$_}==1} keys %tunnels));
                #-1 == last element
                print "\n";
	}else{
		print "severeProblem\n";
		print "[[base-ipsec.missingTunnel]]\n";
	}

}
