#!/usr/bin/perl -w

use lib '/usr/sausalito/perl';
use Sauce::Util;

$_ = $ENV{PLUTO_VERB};

/prepare-(?:host|client)/ && prepare() ||
/((?:un)?route)-(?:host|client)/ && route($1) ||
/(up|down)-(host|client)/ && updown($1, $2) ||

exit(0);


sub prepare{
	#translate prepare-(host|client) from _updown
	if("$ENV{PLUTO_PEER_CLIENT_NET}/$ENV{PLUTO_PEER_CLIENT_MASK}" eq "0.0.0.0/0.0.0.0"){
                # horrible kludge for obscure routing bug with opportunistic
                $parms1="-net 0.0.0.0 netmask 128.0.0.0";
                $parms2="-net 128.0.0.0 netmask 128.0.0.0";
                system("route del $parms1 2>&1 ; route del $parms2 2>&1");
	}else{
                $parms="-net $ENV{PLUTO_PEER_CLIENT_NET} netmask $ENV{PLUTO_PEER_CLIENT_MASK}";
                system("route del $parms 2>&1");
	}
}

sub route{
	my $action = $_[0] eq "route"?"add":"del";
	#routing stuff here from _updown
        $parms="-net $ENV{PLUTO_PEER_CLIENT_NET} netmask $ENV{PLUTO_PEER_CLIENT_MASK}";
        $parms2="dev $ENV{PLUTO_INTERFACE} gw $ENV{PLUTO_NEXT_HOP}";

	if("$ENV{PLUTO_PEER_CLIENT_NET}/$ENV{PLUTO_PEER_CLIENT_MASK}" eq "0.0.0.0/0.0.0.0"){
                # horrible kludge for obscure routing bug with opportunistic
                system("route $action -net 0.0.0.0 netmask 128.0.0.0 $parms2 &&
                        route $action -net 128.0.0.0 netmask 128.0.0.0 $parms2");
	}else{
		system("route $action $parms $parms2");
	}
}

sub updown{
	my($action, $target) = @_;
	#do firewall stuff here
	my $command="";

	my $start = "#begin rule for ipsec connection $ENV{PLUTO_CONNECTION}";
	my $end = "#end rule for ipsec connection $ENV{PLUTO_CONNECTION}";

	if($target eq "client"){
		#client stuff
		if($action eq "up"){
			#up stuff
			system("ipchains -I forward -b -s $ENV{PLUTO_MY_CLIENT_NET}/$ENV{PLUTO_MY_CLIENT_MASK} -d $ENV{PLUTO_PEER_CLIENT_NET}/$ENV{PLUTO_PEER_CLIENT_MASK} -j ACCEPT");
			$command="ipchains -I 2 forward -b -s $ENV{PLUTO_MY_CLIENT_NET}/$ENV{PLUTO_MY_CLIENT_MASK} -d $ENV{PLUTO_PEER_CLIENT_NET}/$ENV{PLUTO_PEER_CLIENT_MASK} -j ACCEPT";
		}else{
			#down stuff
			system("ipchains -D forward -b -s $ENV{PLUTO_MY_CLIENT_NET}/$ENV{PLUTO_MY_CLIENT_MASK} -d $ENV{PLUTO_PEER_CLIENT_NET}/$ENV{PLUTO_PEER_CLIENT_MASK} -j ACCEPT");
			$command = undef;
		}
	}else{
		#host stuff
	}

	Sauce::Util::replaceblock(
		"/etc/ipchains.conf",
		$start,
		$command,
		$end,
		);

}


